
/**** DATABASES NEEDED *************************************;

The databases used in this code are listed below. Please read the accompanyning Data description sheet for instructions on how databases B, C, E, and F are constructed.

A. Annual Government Contracts: Contracts2000 to Contracts2016 (downloaded from https://www.usaspending.gov/)

B. Link table between parentdunsnumber and gvkey: all_contracts

C. Case allegations: cases_wb

D. Compustat variables: funda (fundamentals annual) and fundq (fundamentals quarterly)

E. Political variables: Political_connections2

F. Political connections: Board

***********************************************************/;

libname wb 'YOUR_PATH';


**** 1 - Use publicly available data about government contracts from: https://www.usaspending.gov/ 

* Build data set of all government contracts that are linked to a publicly traded firm;

data wb.contracts2000_v2;set wb.contracts2000;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2001_v2;set wb.contracts2001;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2002_v2;set wb.contracts2002;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2003_v2;set wb.contracts2003;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2004_v2;set wb.contracts2004;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2005_v2;set wb.contracts2005;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2006_v2;set wb.contracts2006;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2007_v2;set wb.contracts2007;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2008_v2;set wb.contracts2008;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2009_v2;set wb.contracts2009;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2010_v2;set wb.contracts2010;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2011_v2;set wb.contracts2011;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2012_v2;set wb.contracts2012;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2013_v2;set wb.contracts2013;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2014_v2;set wb.contracts2014;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2015_v2;set wb.contracts2015;parentdunsnumber_n = parentdunsnumber+1-1;run;
data wb.contracts2016_v2;set wb.contracts2016;parentdunsnumber_n = parentdunsnumber+1-1;run;

*Merge GVKEYs ;
proc sql; create table wb.contracts2000_gvkey as select * from wb.contracts2000_v2 left join wb.all_contracts on contracts2000_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2001_gvkey as select * from wb.contracts2001_v2 left join wb.all_contracts on contracts2001_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2002_gvkey as select * from wb.contracts2002_v2 left join wb.all_contracts on contracts2002_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2003_gvkey as select * from wb.contracts2003_v2 left join wb.all_contracts on contracts2003_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2004_gvkey as select * from wb.contracts2004_v2 left join wb.all_contracts on contracts2004_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2005_gvkey as select * from wb.contracts2005_v2 left join wb.all_contracts on contracts2005_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2006_gvkey as select * from wb.contracts2006_v2 left join wb.all_contracts on contracts2006_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2007_gvkey as select * from wb.contracts2007_v2 left join wb.all_contracts on contracts2007_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2008_gvkey as select * from wb.contracts2008_v2 left join wb.all_contracts on contracts2008_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2009_gvkey as select * from wb.contracts2009_v2 left join wb.all_contracts on contracts2009_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2010_gvkey as select * from wb.contracts2010_v2 left join wb.all_contracts on contracts2010_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2011_gvkey as select * from wb.contracts2011_v2 left join wb.all_contracts on contracts2011_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2012_gvkey as select * from wb.contracts2012_v2 left join wb.all_contracts on contracts2012_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2013_gvkey as select * from wb.contracts2013_v2 left join wb.all_contracts on contracts2013_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2014_gvkey as select * from wb.contracts2014_v2 left join wb.all_contracts on contracts2014_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2015_gvkey as select * from wb.contracts2015_v2 left join wb.all_contracts on contracts2015_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;
proc sql; create table wb.contracts2016_gvkey as select * from wb.contracts2016_v2 left join wb.all_contracts on contracts2016_v2.parentdunsnumber_n = all_contracts.parentdunsnumber_n; quit;

*Drop firms without GVKEY match;
data wb.contracts2000_gvkey2; set wb.contracts2000_gvkey (where=(gvkey ne .));run;
data wb.contracts2001_gvkey2; set wb.contracts2001_gvkey (where=(gvkey ne .));run;
data wb.contracts2002_gvkey2; set wb.contracts2002_gvkey (where=(gvkey ne .));run;
data wb.contracts2003_gvkey2; set wb.contracts2003_gvkey (where=(gvkey ne .));run;
data wb.contracts2004_gvkey2; set wb.contracts2004_gvkey (where=(gvkey ne .));run;
data wb.contracts2005_gvkey2; set wb.contracts2005_gvkey (where=(gvkey ne .));run;
data wb.contracts2006_gvkey2; set wb.contracts2006_gvkey (where=(gvkey ne .));run;
data wb.contracts2007_gvkey2; set wb.contracts2007_gvkey (where=(gvkey ne .));run;
data wb.contracts2008_gvkey2; set wb.contracts2008_gvkey (where=(gvkey ne .));run;
data wb.contracts2009_gvkey2; set wb.contracts2009_gvkey (where=(gvkey ne .));run;
data wb.contracts2010_gvkey2; set wb.contracts2010_gvkey (where=(gvkey ne .));run;
data wb.contracts2011_gvkey2; set wb.contracts2011_gvkey (where=(gvkey ne .));run;
data wb.contracts2012_gvkey2; set wb.contracts2012_gvkey (where=(gvkey ne .));run;
data wb.contracts2013_gvkey2; set wb.contracts2013_gvkey (where=(gvkey ne .));run;
data wb.contracts2014_gvkey2; set wb.contracts2014_gvkey (where=(gvkey ne .));run;
data wb.contracts2015_gvkey2; set wb.contracts2015_gvkey (where=(gvkey ne .));run;
data wb.contracts2016_gvkey2; set wb.contracts2016_gvkey (where=(gvkey ne .));run;

*create one dataset for all years;
data wb.contracts_gvkey; set wb.contracts2000_gvkey2 wb.contracts2001_gvkey2 wb.contracts2002_gvkey2 wb.contracts2003_gvkey2 wb.contracts2004_gvkey2 wb.contracts2005_gvkey2 wb.contracts2006_gvkey2 
wb.contracts2007_gvkey2 wb.contracts2008_gvkey2 wb.contracts2009_gvkey2 wb.contracts2010_gvkey2 wb.contracts2011_gvkey2 wb.contracts2012_gvkey2 wb.contracts2013_gvkey2 wb.contracts2014_gvkey2 
wb.contracts2015_gvkey2  wb.contracts2016_gvkey2 ; run;

**** 2 - Merge violations to database with all government contracts (use cases_wb);

proc sql; create table wb.contracts_gvkey_viol as select * from wb.contracts_gvkey left join wb.cases_wb on contracts_gvkey.gvkey = cases_wb.gvkey;quit; * Note: This step will create duplicates for every count - (helpful for firms with multiple allegations);

* drop firms without violation;
data wb.contracts_gvkey_viol2; set wb.contracts_gvkey_viol; where count ne .; run;

*create contract variables;
data wb.contracts_gvkey_viol2; set wb.contracts_gvkey_viol2;
agency = substr(maj_agency_cat,1,4);
agency2= agency+1-1;
signed_date = input(signeddate,mmddyy10.);format signed_date mmddyy10.;
dollars_contract = dollarsobligated+1-1;
annualrevenue2 = annualrevenue+1-1;
* Contract type;
fixed_price1 = 0 ; if substr(typeofcontractpricing,1,1) eq 'J' or substr(typeofcontractpricing,1,1) eq 'A' then fixed_price1 = 1;
fixed_price2 = 0 ; if substr(typeofcontractpricing,1,1) eq 'M' then fixed_price2 = 1;
fixed_price3 = 0 ; if substr(typeofcontractpricing,1,1) eq 'L' then fixed_price3 = 1;
fixed_price4 = 0 ; if substr(typeofcontractpricing,1,1) eq 'B' then fixed_price4 = 1;
fixed_price5 = 0 ; if substr(typeofcontractpricing,1,1) eq 'K' then fixed_price5 = 1;
Cost_plus1 = 0 ; if substr(typeofcontractpricing,1,1) eq 'T' then Cost_plus1 = 1;
Cost_plus2 = 0 ; if substr(typeofcontractpricing,1,1) eq 'R' then Cost_plus2 = 1;
Cost_plus3 = 0 ; if substr(typeofcontractpricing,1,1) eq 'S' then Cost_plus3 = 1;
Cost_plus4 = 0 ; if substr(typeofcontractpricing,1,1) eq 'V' then Cost_plus4 = 1;
Cost_plus5 = 0 ; if substr(typeofcontractpricing,1,1) eq 'U' or substr(typeofcontractpricing,1,1) eq 'Y' or substr(typeofcontractpricing,1,1) eq 'Z' then Cost_plus5 = 1;
fixed_contract = 0 ; if fixed_price1 eq 1 or fixed_price2 eq 1 or fixed_price3 eq 1 or fixed_price4 eq 1 or fixed_price5 eq 1 then fixed_contract=1;
cost_contract = 0 ; if Cost_plus1 eq 1 or Cost_plus2 eq 1 or Cost_plus3 eq 1 or Cost_plus4 eq 1 or Cost_plus5 eq 1 then cost_contract =1;
* Product type;
rd = 0 ; if substr(productorservicecode,1,1) eq 'A' then rd =1;
product = 0 ; if substr(productorservicecode,1,1) eq '1' or substr(productorservicecode,1,1) eq '2' or substr(productorservicecode,1,1) eq '3' or
substr(productorservicecode,1,1) eq '4' or substr(productorservicecode,1,1) eq '5' or substr(productorservicecode,1,1) eq '6' or 
substr(productorservicecode,1,1) eq '7' or substr(productorservicecode,1,1) eq '8' or substr(productorservicecode,1,1) eq '9'  then product =1;
service =0 ; if rd eq 0 and product eq 0 and productorservicecode ne '' then service =1;
not_disclosed = 0; if productorservicecode eq '' then not_disclosed =1;run;
run;

* Create government fiscal quarter;
data wb.contracts_gvkey_viol2; set wb.contracts_gvkey_viol2;
m = month(signed_date);
y = year(signed_date);
if m ge 10 and m le 12 then yq = cats(y+1,1);
if m ge 1 and m le 3 then  yq = cats(y,2);
if m ge 4 and m le 6 then  yq = cats(y,3);
if m ge 7 and m le 9 then  yq = cats(y,4);
yq2=yq*1;run;

* Create analysis variables; 
data wb.contracts_gvkey_viol2;set wb.contracts_gvkey_viol2;
DA = 0; if agency2 eq agency_code2 then DA =1;
run;

data wb.contracts_gvkey_viol3; set wb.contracts_gvkey_viol2; 
def_total = DA*dollars_contract;
* Type of contract;
fix_total = fixed_contract*dollars_contract;
def_fix_total = DA*fixed_contract*dollars_contract;
cost_total = cost_contract*dollars_contract;
def_cost_total = DA*cost_contract*dollars_contract;
* Product type (rd, product, service);
rd_total = rd*dollars_contract;
def_rd_total = DA*rd*dollars_contract;
product_total = product*dollars_contract;
def_product_total = DA*product*dollars_contract;
service_total = service*dollars_contract;
def_service_total = DA*service*dollars_contract;
* Product type and contract type;
fix_rd_total = fixed_contract*rd*dollars_contract;
def_fix_rd_total = DA*fixed_contract*rd*dollars_contract; 
fix_product_total = fixed_contract*product*dollars_contract;
def_fix_product_total = DA*fixed_contract*product*dollars_contract; 
fix_service_total = fixed_contract*service*dollars_contract;
def_fix_service_total = DA*fixed_contract*service*dollars_contract; 
cost_rd_total = cost_contract*rd*dollars_contract;
def_cost_rd_total = DA*cost_contract*rd*dollars_contract; 
cost_product_total = cost_contract*product*dollars_contract;
def_cost_product_total = DA*cost_contract*product*dollars_contract; 
cost_service_total = cost_contract*service*dollars_contract;
def_cost_service_total = DA*cost_contract*service*dollars_contract; 
run;

proc sort data = wb.contracts_gvkey_viol3; by gvkey yq2 count;run;

proc means data = wb.contracts_gvkey_viol3 (where=(dollars_contract ge 0)) noprint;
by gvkey yq2 count;
var dollars_contract def_total fix_total def_fix_total 
cost_total def_cost_total 
rd_total def_rd_total product_total def_product_total service_total def_service_total
cost_rd_total def_cost_rd_total  cost_product_total def_cost_product_total  cost_service_total def_cost_service_total; 
output out=wb.contracts_aggregated sum=/autoname;
run;

proc sort data=wb.contracts_aggregated nodupkey; by gvkey yq2 count;run;

* Add a year-quarter numeric variable: yq_n (1990q1 is 1, 1990q2 is 2, ..., 2018q4 is 116);

proc sql; create table wb.contracts_aggregated_2 as select * from wb.contracts_aggregated left join wb.yq_codes on contracts_aggregated.yq2 = yq_codes.yq;quit;

***** 3 - Merge into Compustat: Create full panel;

* Get Fyr by gvkey and add fiscal years;

data wb.fyend; set wb.funda;
gvkey2 = gvkey*1;
keep fyearq fyr gvkey2;
run; 

proc sort data= wb.fyend nodupkey;by gvkey2;run;

data wb.fyend; set  wb.fyend; keep gvkey2 fyr;run;

proc sql; create table wb.contracts_aggregated_2 as select * from wb.contracts_aggregated_2 left join wb.fyend on contracts_aggregated_2.gvkey = fyend.gvkey2;quit;

data wb.contracts_aggregated_2; set wb.contracts_aggregated_2;
y = round(yq2/10);
q = yq2 - y*10;
run;

data wb.contracts_aggregated_2; set wb.contracts_aggregated_2;

if fyr eq 1 and q eq 1 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 1 and q eq 2 then  yq_f2 = y*10 + 1;
if fyr eq 1 and q eq 3 then  yq_f2 = y*10 + 2;
if fyr eq 1 and q eq 4 then  yq_f2 = y*10 + 3;

if fyr eq 2 and q eq 1 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 2 and q eq 2 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 2 and q eq 3 then  yq_f2 = y*10 + 1;
if fyr eq 2 and q eq 4 then  yq_f2 = y*10 + 2;

if fyr eq 3 and q eq 1 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 3 and q eq 2 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 3 and q eq 3 then  yq_f2 = y*10 + 1;
if fyr eq 3 and q eq 4 then  yq_f2 = y*10 + 2;

if fyr eq 4 and q eq 1 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 4 and q eq 2 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 4 and q eq 3 then  yq_f2 = y*10 + 1;
if fyr eq 4 and q eq 4 then  yq_f2 = y*10 + 2;

if fyr eq 5 and q eq 1 then  yq_f2 = (y-1)*10 + 2;
if fyr eq 5 and q eq 2 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 5 and q eq 3 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 5 and q eq 4 then  yq_f2 = y*10 + 1;

if fyr eq 6 and q eq 1 then  yq_f2 = (y-1)*10 + 2;
if fyr eq 6 and q eq 2 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 6 and q eq 3 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 6 and q eq 4 then  yq_f2 = y*10 + 1;

if fyr eq 7 and q eq 1 then  yq_f2 = (y-1)*10 + 2;
if fyr eq 7 and q eq 2 then  yq_f2 = (y-1)*10 + 3;
if fyr eq 7 and q eq 3 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 7 and q eq 4 then  yq_f2 = y*10 + 1;

if fyr eq 8 and q eq 1 then  yq_f2 = y*10 + 1;
if fyr eq 8 and q eq 2 then  yq_f2 = y*10 + 2;
if fyr eq 8 and q eq 3 then  yq_f2 = y*10 + 3;
if fyr eq 8 and q eq 4 then  yq_f2 = y*10 + 4;

if fyr eq 9 and q eq 1 then  yq_f2 = y*10 + 1;
if fyr eq 9 and q eq 2 then  yq_f2 = y*10 + 2;
if fyr eq 9 and q eq 3 then  yq_f2 = y*10 + 3;
if fyr eq 9 and q eq 4 then  yq_f2 = y*10 + 4;

if fyr eq 10 and q eq 1 then  yq_f2 = y*10 + 1;
if fyr eq 10 and q eq 2 then  yq_f2 = y*10 + 2;
if fyr eq 10 and q eq 3 then  yq_f2 = y*10 + 3;
if fyr eq 10 and q eq 4 then  yq_f2 = y*10 + 4;

if fyr eq 11 and q eq 1 then  yq_f2 = (y-1)*10 +4 ;
if fyr eq 11 and q eq 2 then  yq_f2 = y*10 + 1;
if fyr eq 11 and q eq 3 then  yq_f2 = y*10 + 2;
if fyr eq 11 and q eq 4 then  yq_f2 = y*10 + 3;

if fyr eq 12 and q eq 1 then  yq_f2 = (y-1)*10 + 4;
if fyr eq 12 and q eq 2 then  yq_f2 = y*10 + 1;
if fyr eq 12 and q eq 3 then  yq_f2 = y*10 + 2;
if fyr eq 12 and q eq 4 then  yq_f2 = y*10 + 3;
run;

* Add info about WB violations (by gvkey and violation count);

proc sql; create table wb.contracts_aggregated_3 as select * from wb.contracts_aggregated_2 left join wb.cases_wb on contracts_aggregated_2.gvkey=cases_wb.gvkey and contracts_aggregated_2.count=cases_wb.count;quit;

* Merge into Compustat to create panel;

data wb.compustat_q2; set wb.fundq; yq_f2 = fyearq*10+fqtr;gvkey2=gvkey*1; run;  

* Merge basic info about wb firms (gvkey, count, wb);

data wb.basic_wb; set wb.cases_wb;wb=1; keep gvkey count wb     election_date received_date  agency_code2  serious_doj serious_settle time_doj  yq2_wb yqwb_n;run;

proc sql; create table wb.compustat_q_merge as select * from wb.compustat_q2 left join wb.basic_wb on compustat_q2.gvkey2=basic_wb.gvkey;quit;

* Merge aggregate contracts into compustat;

proc sql; create table wb.panel1 as select * from wb.compustat_q_merge left join wb.contracts_aggregated_2 on compustat_q_merge.gvkey2=contracts_aggregated_2.gvkey and compustat_q_merge.yq_f2=contracts_aggregated_2.yq_f2 and compustat_q_merge.count=contracts_aggregated_2.count;quit;

* Cleaning data ;

data wb.panel2;
set wb.panel1;
if dollars_contract_sum eq . then dollars_contract_sum =0;
if def_total_sum eq . then def_total_sum =0;
if fix_total_sum eq . then fix_total_sum =0;
if def_fix_total_sum eq . then def_fix_total_sum =0;
if cost_total_sum eq . then cost_total_sum =0;
if def_cost_total_sum eq . then def_cost_total_sum =0;
if rd_total_sum eq . then rd_total_sum =0;
if def_rd_total_sum eq . then def_rd_total_sum =0;
if product_total_sum eq . then product_total_sum =0;
if def_product_total_sum eq . then def_product_total_sum =0;
if service_total_sum eq . then service_total_sum =0;
if def_service_total_sum eq . then def_service_total_sum =0;
if cost_rd_total_sum eq . then cost_rd_total_sum =0;
if def_cost_rd_total_sum eq . then def_cost_rd_total_sum =0;
if cost_product_total_sum eq . then cost_product_total_sum =0;
if def_cost_product_total_sum eq . then def_cost_product_total_sum =0;
if cost_service_total_sum eq . then cost_service_total_sum =0;
if def_cost_service_total_sum eq . then def_cost_service_total_sum =0;
run;


**** Create event windows;
data wb.panel3;
set wb.panel2;
where wb eq 1;
run;

* Add yq_n for all observations ;

data wb.yq_link; set wb.contracts_aggregated_3; keep fyr yq_f2 yq_n; run;
data wb.yq_link; set  wb.yq_link; rename yq_n = yq_n2;run;
proc sort data=wb.yq_link nodupkey; by fyr yq_f2;run;

proc sql; create table wb.panel4 as select * from wb.panel3 left join wb.yq_link on panel3.fyr=yq_link.fyr and panel3.yq_f2=yq_link.yq_f2;quit;

data wb.panel4;
set wb.panel4;
pre = 0; 
if yq_n2 lt yqwb_n then pre =1;
post = 0;
if yq_n2 gt yqwb_n then post =1;
pre_1 = 0;
if yq_n2 eq yqwb_n-1 then pre_1 =1;
pre_2 = 0;
if yq_n2 eq yqwb_n-2 then pre_2 =1;
pre_3 = 0;
if yq_n2 eq yqwb_n-3 then pre_3 =1;
pre_4 = 0;
if yq_n2 eq yqwb_n-4 then pre_4 =1;
pre_5 = 0;
if yq_n2 eq yqwb_n-5 then pre_5 =1;
pre_6 = 0;
if yq_n2 eq yqwb_n-6 then pre_6 =1;
pre_7 = 0;
if yq_n2 eq yqwb_n-7 then pre_7 =1;
pre_8 = 0;
if yq_n2 eq yqwb_n-8 then pre_8 =1;
pre_9 = 0;
if yq_n2 eq yqwb_n-9 then pre_9 =1;
pre_10 = 0;
if yq_n2 eq yqwb_n-10 then pre_10 =1;
post_1 = 0;
if yq_n2 eq yqwb_n+1 then post_1 =1;
post_2 = 0;
if yq_n2 eq yqwb_n+2 then post_2 =1;
post_3 = 0;
if yq_n2 eq yqwb_n+3 then post_3 =1;
post_4 = 0;
if yq_n2 eq yqwb_n+4 then post_4 =1;
post_5 = 0;
if yq_n2 eq yqwb_n+5 then post_5 =1;
post_6 = 0;
if yq_n2 eq yqwb_n+6 then post_6 =1;
post_7 = 0;
if yq_n2 eq yqwb_n+7 then post_7 =1;
post_8 = 0;
if yq_n2 eq yqwb_n+8 then post_8 =1;
post_9 = 0;
if yq_n2 eq yqwb_n+9 then post_9 =1;
post_10 = 0;
if yq_n2 eq yqwb_n+10 then post_10 =1;
run;

**** Create yqe_n to have test for pre and after DOJ election;

* Create yqe_n variable;

data wb.panel4; set wb.panel4;
m_e = month(election_date2);
y_e = year(election_date2);
if m_e ge 10 and m_e le 12 then yq_e = cats(y_e+1,1);
if m_e ge 1 and m_e le 3 then  yq_e = cats(y_e,2);
if m_e ge 4 and m_e le 6 then  yq_e = cats(y_e,3);
if m_e ge 7 and m_e le 9 then  yq_e = cats(y_e,4);
run;
data wb.panel4; set wb.panel4; yq_e2=yq_e*1;run;

data wb.yq_codes_e; set wb.yq_codes; rename yq_n = yqe_n;run;
proc sql; create table wb.panel5 as select * from wb.panel4 left join wb.yq_codes_e on panel4.yq_e2 = yq_codes_e.yq;quit;

* Add event window dummies related to DOJ election decision;

data wb.panel5;
set wb.panel5;
inter_1 = 0;
if yq_n2 eq yqe_n+1 then inter_1 =1;
inter_2 = 0;
if yq_n2 eq yqe_n+2 then inter_2 =1;
inter_3 = 0;
if yq_n2 eq yqe_n+3 then inter_3 =1;
inter_4 = 0;
if yq_n2 eq yqe_n+4 then inter_4 =1;
inter_5 = 0;
if yq_n2 eq yqe_n+5 then inter_5 =1;
inter_6 = 0;
if yq_n2 eq yqe_n+6 then inter_6 =1;
inter_7 = 0;
if yq_n2 eq yqe_n+7 then inter_7 =1;
inter_8 = 0;
if yq_n2 eq yqe_n+8 then inter_8 =1;
inter_9 = 0;
if yq_n2 eq yqe_n+9 then inter_9 =1;
inter_10 = 0;
if yq_n2 eq yqe_n+10 then inter_10 =1;
run;

**** 7. Create defrauded agency dummies;

data wb.def_agencies; set wb.cases_wb;keep agency_code2;run;
data wb.def_agencies; set wb.def_agencies;rename agency_code2=defrauded_ag;run;
proc sort data = wb.def_agencies nodupkey;by defrauded_ag;run;
data wb.def_agencies;set wb.def_agencies (where=(defrauded_ag ne .)); run;
data wb.def_agencies;set wb.def_agencies; def_ag +1; by defrauded_ag;run;

proc sql; create table wb.panel6 as select * from wb.panel5 left join wb.def_agencies on panel5.agency_code2 = def_agencies.defrauded_ag;quit;

data wb.panel6; set wb.panel6;
def_ag_1 = 0;
if def_ag eq 1 then def_ag_1 =1;
def_ag_2 = 0;
if def_ag eq 2 then def_ag_2 =1;
def_ag_3 = 0;
if def_ag eq 3 then def_ag_3 =1;
def_ag_4 = 0;
if def_ag eq 4 then def_ag_4 =1;
def_ag_5 = 0;
if def_ag eq 5 then def_ag_5 =1;
def_ag_6 = 0;
if def_ag eq 6 then def_ag_6 =1;
def_ag_7 = 0;
if def_ag eq 7 then def_ag_7 =1;
def_ag_8 = 0;
if def_ag eq 8 then def_ag_8 =1;
def_ag_9 = 0;
if def_ag eq 9 then def_ag_9 =1;
def_ag_10 = 0;
if def_ag eq 10 then def_ag_10 =1;
def_ag_11 = 0;
if def_ag eq 11 then def_ag_11 =1;
def_ag_12 = 0;
if def_ag eq 12 then def_ag_12 =1;
def_ag_13 = 0;
if def_ag eq 13 then def_ag_13 =1;
def_ag_14 = 0;
if def_ag eq 14 then def_ag_14 =1;
def_ag_15 = 0;
if def_ag eq 15 then def_ag_15 =1;
def_ag_16 = 0;
if def_ag eq 16 then def_ag_16 =1;
def_ag_17 = 0;
if def_ag eq 17 then def_ag_17 =1;
def_ag_18 = 0;
if def_ag eq 18 then def_ag_18 =1;
def_ag_19 = 0;
if def_ag eq 19 then def_ag_19 =1;
def_ag_20 = 0;
if def_ag eq 20 then def_ag_20 =1;
def_ag_21 = 0;
if def_ag eq 21 then def_ag_21 =1;
def_ag_22 = 0;
if def_ag eq 22 then def_ag_22 =1;
def_ag_23 = 0;
if def_ag eq 23 then def_ag_23 =1;
def_ag_24 = 0;
if def_ag eq 24 then def_ag_24 =1;
run;

**** Other analysis variables;
* Political connections variables: PAC contributions and Lobby; 

data wb.political; set govt.political_connections2; keep gvkey fyear lobbydummy pacdummy lobbyamount firmpacamount; run;
data wb.political; set wb.political; gvkey2= gvkey*1;run;
data wb.political; set wb.political;keep gvkey2 fyear lobbydummy pacdummy lobbyamount firmpacamount; run;
proc sql; create table wb.political2 as select * from wb.cases_wb left join wb.political on cases_wb.gvkey=political.gvkey2 and cases_wb.fyear=political.fyear ;quit;
data wb.political2; set wb.political2; keep gvkey count lobbydummy pacdummy lobbyamount firmpacamount; run;
data wb.political2; set wb.political2; if lobbydummy eq . then lobbydummy =0; if pacdummy eq . then pacdummy = 0;if lobbyamount eq . then lobbyamount =0; if firmpacamount eq . then firmpacamount = 0;run;

proc sql; create table wb.panel7 as select * from wb.panel6 left join wb.political2 on panel6.gvkey2=political2.gvkey and panel6.count=political2.count;quit;

* Board member is politically connected;

proc sql; create table wb.panel7 as select * from wb.panel7 left join wb.board on panel7.gvkey2=board.gvkey2 and panel7.fyearq=board.fyear;quit;

data wb.panel7; set wb.panel7;
if connectedboard eq . then connectedboard=0;
run;

** Generate variables;

data wb.panel8;
set wb.panel7;
 pct_def_agency= def_total_sum / dollars_contract_sum;
 pct_cost_def_agency = def_cost_total_sum / cost_total_sum;
 pct_cost_service = cost_service_total_sum / service_total_sum; 
 pct_cost_product = cost_product_total_sum / product_total_sum ; 
 pct_cost_rd = cost_rd_total_sum / rd_total_sum  ;
 pct_def_agency_service=def_service_total_sum/def_total_sum;
 pct_def_agency_product=def_product_total_sum/def_total_sum;
 pct_def_agency_rd=def_rd_total_sum/def_total_sum;
 pct_cost_def_agency_service=def_cost_service_total_sum/def_service_total_sum;
 pct_cost_def_agency_product=  def_cost_product_total_sum/def_product_total_sum;
 pct_cost_def_agency_rd=def_cost_rd_total_sum/def_rd_total_sum;

if time_doj>1000 then long_investigation=1 ;
if  long_investigation eq . then long_investigation=0; 

if yqwb_n= yq_n2 then fraudq=1; 
if  fraudq eq . then fraudq=0; 

if pacdummy=1 then pc=1 ;
if lobbydummy=1 then pc=1;
if pc eq . then pc=0; 

sumpc= lobbyamount + firmpacamount;
if sumpc eq . then sumpc=0; 
logsumpc=log(1+sumpc);
run;

proc sort data=wb.panel8; by gvkey datadate;run;

%macro process(variable);
retain help_&variable;
if (not missing(&variable) or first.gvkey eq 1 )
then _&variable = &variable;
else &variable = _&variable;
drop _&variable;
%mend;

data wb.panel8;
set wb.panel8;
by gvkey;
%process(pct_def_agency)
%process(pct_cost_def_agency)
%process(pct_cost_service)
%process(pct_cost_product)
%process(pct_cost_rd)
%process(pct_def_agency_service)
%process(pct_def_agency_product)
%process(pct_def_agency_rd)
%process(pct_cost_def_agency_service)
%process(pct_cost_def_agency_product)
%process(pct_cost_def_agency_rd)
run;

*  Top 100 contractors & top 100 defense contractors;

data wb.contracts_minimal_2000;set wb.contracts2000_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2001;set wb.contracts2001_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2002;set wb.contracts2002_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2003;set wb.contracts2003_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2004;set wb.contracts2004_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2005;set wb.contracts2005_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2006;set wb.contracts2006_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2007;set wb.contracts2007_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2008;set wb.contracts2008_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2009;set wb.contracts2009_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2010;set wb.contracts2010_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2011;set wb.contracts2011_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2012;set wb.contracts2012_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2013;set wb.contracts2013_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2014;set wb.contracts2014_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2015;set wb.contracts2015_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;
data wb.contracts_minimal_2016;set wb.contracts2016_gvkey;keep dollarsobligated parentdunsnumber maj_agency_cat signeddate gvkey; run;

%macro largestcontractors(year);
%do i=2000 %to &year;
data wb.contracts_minimal_&i;set wb.contracts_minimal_&i;
agency = substr(maj_agency_cat,1,4);
agency2= agency+1-1;
signed_date = input(signeddate,mmddyy10.);format signed_date mmddyy10.;
dollars_contract = dollarsobligated+1-1;
run;
proc sort data=wb.contracts_minimal_&i;by parentdunsnumber;run;
proc means data=wb.contracts_minimal_&i noprint;
by parentdunsnumber;
var dollars_contract;
output out=wb.contract_by_co_&i sum=/autoname;
run;
proc sort data=wb.contract_by_co_&i;by descending dollars_contract_sum;run;
data wb.contract_by_co_&i; set wb.contract_by_co_&i;year_rank =&i; rank_contractor +1;run;
data wb.contract_by_co_&i; set wb.contract_by_co_&i;largest_100=0; if rank_contractor le 100 then largest_100=1;run;
data wb.contract_by_co_&i; set wb.contract_by_co_&i;keep parentdunsnumber year_rank largest_100;run;
%end;
%mend largestcontractors;

%largestcontractors(2016)

data wb.largest_contractors; set wb.contract_by_co_2000 wb.contract_by_co_2001 wb.contract_by_co_2002 wb.contract_by_co_2003
wb.contract_by_co_2004 wb.contract_by_co_2005 wb.contract_by_co_2006 wb.contract_by_co_2007 wb.contract_by_co_2008 wb.contract_by_co_2009
wb.contract_by_co_2010 wb.contract_by_co_2011 wb.contract_by_co_2012 wb.contract_by_co_2013 wb.contract_by_co_2014 wb.contract_by_co_2015 wb.contract_by_co_2016;
run;

proc sort data=wb.largest_contractors;by parentdunsnumber;run;

* Dod;

%macro largestdodcontractors(year);
%do i=2000 %to &year;
proc sort data=wb.contracts_minimal_&i;by parentdunsnumber;run;
proc means data=wb.contracts_minimal_&i (where=(agency2 eq 9700)) noprint ;
by parentdunsnumber;
var dollars_contract;
output out=wb.contractdod_by_co_&i sum=/autoname;
run;
proc sort data=wb.contractdod_by_co_&i;by descending dollars_contract_sum;run;
data wb.contractdod_by_co_&i; set wb.contractdod_by_co_&i;year_rank =&i; rank_dodcontractor +1;run;
data wb.contractdod_by_co_&i; set wb.contractdod_by_co_&i;largestdod_100=0; if rank_dodcontractor le 100 then largestdod_100=1;run;
data wb.contractdod_by_co_&i; set wb.contractdod_by_co_&i;keep parentdunsnumber year_rank largestdod_100;run;
%end;
%mend largestdodcontractors;

%largestdodcontractors(2016)

data wb.largestdod_contractors; set wb.contractdod_by_co_2000 wb.contractdod_by_co_2001 wb.contractdod_by_co_2002 wb.contractdod_by_co_2003
wb.contractdod_by_co_2004 wb.contractdod_by_co_2005 wb.contractdod_by_co_2006 wb.contractdod_by_co_2007 wb.contractdod_by_co_2008 wb.contractdod_by_co_2009
wb.contractdod_by_co_2010 wb.contractdod_by_co_2011 wb.contractdod_by_co_2012 wb.contractdod_by_co_2013 wb.contractdod_by_co_2014 wb.contractdod_by_co_2015 wb.contractdod_by_co_2016;
run;

proc sql;create table wb.largest_contractors_all_dod as select * from wb.largest_contractors left join wb.largestdod_contractors on largest_contractors.parentdunsnumber=largestdod_contractors.parentdunsnumber and largest_contractors.year_rank=largestdod_contractors.year_rank;quit;

proc sql;create table wb.largest_contractors_all_dod as select * from wb.largest_contractors_all_dod left join wb.link_table_complete on largest_contractors_all_dod.parentdunsnumber=link_table_complete.parentdunsnumber;run;

**** Add FF12 industry codes;

data wb.sic;set wb.compustat_sic;
gvkey2=gvkey*1;
sic_n = sic*1;
keep gvkey gvkey2 sic sic_n;
run;
proc sort data=wb.sic nodupkey; by gvkey2;run;
proc sql;create table wb.panel8 as select * from wb.panel8 left join wb.sic on panel8.gvkey2=sic.gvkey2;quit;

data wb.panel8;set wb.panel8;gvkeyn=cats(gvkey2,count); run; 
data wb.panel8;set wb.panel8;gvkeyn=gvkeyn*1; run; 

data wb.panel8;
set wb.panel8;
*1 NoDur  Consumer NonDurables -- Food, Tobacco, Textiles, Apparel, Leather, Toys;
         if sic_n ge   0100 and sic_n le  0999 	then ind_code=1;
         if sic_n ge   2000 and sic_n le 	2399 	then ind_code=1;
         if sic_n ge   2700 and sic_n le 	2749 	then ind_code=1;
         if sic_n ge   2770 and sic_n le 	2799 	then ind_code=1;
         if sic_n ge   3100 and sic_n le 	3199 	then ind_code=1;
         if sic_n ge   3940 and sic_n le 	3989 	then ind_code=1;
 *2 Durbl  Consumer Durables -- Cars, TVs, Furniture, Household Appliances;
        if sic_n ge   2500 and sic_n le   2519 	then ind_code=2;
        if sic_n ge   2590 and sic_n le 	2599 	then ind_code=2;
        if sic_n ge   3630 and sic_n le 	3659 	then ind_code=2;
        if sic_n ge   3710 and sic_n le 	3711 	then ind_code=2;
        if sic_n ge   3714 and sic_n le 	3714 	then ind_code=2;
        if sic_n ge   3716 and sic_n le 	3716 	then ind_code=2;
        if sic_n ge   3750 and sic_n le 	3751 	then ind_code=2;
        if sic_n ge   3792 and sic_n le 	3792 	then ind_code=2;
        if sic_n ge   3900 and sic_n le 	3939 	then ind_code=2;
        if sic_n ge   3990 and sic_n le 	3999 	then ind_code=2;
* 3 Manuf  Manufacturing -- Machinery, Trucks, Planes, Off Furn, Paper, Com Printing;
        if sic_n ge    2520 and sic_n le  2589 	then ind_code=3;
        if sic_n ge    2600 and sic_n le 	2699 	then ind_code=3;
        if sic_n ge    2750 and sic_n le 	2769 	then ind_code=3;
        if sic_n ge    3000 and sic_n le 	3099 	then ind_code=3;
        if sic_n ge    3200 and sic_n le 	3569 	then ind_code=3;
        if sic_n ge    3580 and sic_n le 	3629 	then ind_code=3;
        if sic_n ge    3700 and sic_n le 	3709 	then ind_code=3;
        if sic_n ge    3712 and sic_n le 	3713 	then ind_code=3;
        if sic_n ge    3715 and sic_n le 	3715 	then ind_code=3;
        if sic_n ge    3717 and sic_n le 	3749 	then ind_code=3;
        if sic_n ge    3752 and sic_n le 	3791 	then ind_code=3;
        if sic_n ge    3793 and sic_n le 	3799 	then ind_code=3;
        if sic_n ge    3830 and sic_n le 	3839 	then ind_code=3;
        if sic_n ge    3860 and sic_n le 	3899 	then ind_code=3;
* 4 Enrgy  Oil, Gas, and Coal Extraction and Products;
        if sic_n ge     1200 and sic_n le 	1399 	then ind_code=4;
        if sic_n ge     2900 and sic_n le 	2999 	then ind_code=4;
* 5 Chems  Chemicals and Allied Products;
        if sic_n ge     2800 and sic_n le 	2829 	then ind_code=5;
        if sic_n ge     2840 and sic_n le 	2899 	then ind_code=5;
* 6 BusEq  Business Equipment -- Computers, Software, and Electronic Equipment;
        if sic_n ge    3570 and sic_n le 	3579 	then ind_code=6;
        if sic_n ge    3660 and sic_n le 	3692 	then ind_code=6;
        if sic_n ge    3694 and sic_n le 	3699 	then ind_code=6;
        if sic_n ge    3810 and sic_n le 	3829 	then ind_code=6;
        if sic_n ge    7370 and sic_n le 	7379 	then ind_code=6;
* 7 Telcm  Telephone and Television Transmission;
         if sic_n ge    4800 and sic_n le 	4899 	then ind_code=7;
* 8 Utils  Utilities;
         if sic_n ge    4900 and sic_n le 	4949 	then ind_code=8;
* 9 Shops  Wholesale, Retail, and Some Services (Laundries, Repair Shops);
        if sic_n ge    5000 and sic_n le 	5999 	then ind_code=9;
        if sic_n ge    7200 and sic_n le 	7299 	then ind_code=9;
        if sic_n ge    7600 and sic_n le 	7699 	then ind_code=9;
*10 Hlth   Healthcare, Medical Equipment, and Drugs;
         if sic_n ge   2830 and sic_n le 	2839 	then ind_code=10;
         if sic_n ge   3693 and sic_n le 	3693 	then ind_code=10;
         if sic_n ge   3840 and sic_n le 	3859 	then ind_code=10;
         if sic_n ge   8000 and sic_n le 	8099 	then ind_code=10;
*11 Money  Finance;
         if sic_n ge   6000 and sic_n le 	6999 	then ind_code=11;
*12 Other  Other -- Mines, Constr, BldMt, Trans, Hotels, Bus Serv, Entertainment;
		 if sic_n > .		and ind_code = .	then ind_code=12;
	if(ind_code=1) then i1=1;			else i1=0;
	if(ind_code=2) then i2=1;			else i2=0;
	if(ind_code=3) then i3=1;			else i3=0;
	if(ind_code=4) then i4=1;			else i4=0;
	if(ind_code=5) then i5=1;			else i5=0;
	if(ind_code=6) then i6=1;			else i6=0;
	if(ind_code=7) then i7=1;			else i7=0;
	if(ind_code=8) then i8=1;			else i8=0;
	if(ind_code=9) then i9=1;			else i9=0;
	if(ind_code=10) then i10=1;		else i10=0;
	if(ind_code=11) then i11=1;		else i11=0;
	if(ind_code=12) then i12=1;		else i12=0;
run;	

*** EXPORT TO STATA;

